<?php

namespace Webkul\SalesforceConnector\Controller\Adminhtml\Orders;

class GetAllExportIds extends \Magento\Backend\App\Action
{
    protected $_resultPageFactory = false;
    // protected $_connection = false;
    // protected $_helper;
    protected $_json;
    // protected $_categoryModel;
    protected $_orderModel;
    protected $_salesOrder;
    // protected $_catalogProductModel;
    public function __construct(
        \Magento\Backend\App\Action\Context $context,
        // \Webkul\SalesforceConnector\Helper\Connection $connection,
        \Magento\Framework\Json\Helper\Data $jsonHelper,
        // \Webkul\SalesforceConnector\Helper\Data $helper,
        \Webkul\SalesforceConnector\Model\OrderFactory $order,
        \Magento\Sales\Model\OrderFactory $salesOrder,
        \Magento\Framework\View\Result\PageFactory $resultPageFactory
    ) {

        $this->_resultPageFactory = $resultPageFactory;
        $this->_json = $jsonHelper;
        $this->_orderModel = $order;
        $this->_salesOrder = $salesOrder;
        // $this->_connection = $connection;
        // $this->_helper = $helper;
        parent::__construct($context);
    }

    public function execute()
    {
        $mapProducts = $exportIds = [];
        if (\Webkul\SalesforceConnector\Helper\Connection::checkConnectionStatus()) {
            $orderModel = $this->_orderModel->create();
            $salesOrderModel = $this->_salesOrder->create();

            $orderCollection = $orderModel
                ->getCollection()
                ->addFieldToSelect('magento_id')
                ->addFieldToFilter('sync_status', '1')
                ->getData();
            $mapProducts = array_column($orderCollection, 'magento_id');
            if ($mapProducts) {
                $collection = $salesOrderModel->getCollection()
                    ->addAttributeToFilter('entity_id', ['nin' => $mapProducts])
                    ->addAttributeToSelect('entity_id');
            } else {
                $collection = $salesOrderModel->getCollection()
                    ->addAttributeToSelect('entity_id');
            }
            $exportIds = $collection->getAllIds();
        } else {
            $this->messageManager
                ->addError(__("Check Connection"));
        }
        $this->getResponse()->setHeader('Content-type', 'application/json');
        $this->getResponse()->setBody($this->_json->jsonEncode($exportIds));
    }

    /*
     * Check permission via ACL resource
     */
    // protected function _isAllowed()
    // {
    //     return $this->_authorization->isAllowed('Webkul_Eshopsync::products_getallexportproducts');
    // }
}
