<?php

/**
 * * Copyright © Magento, Inc. All rights reserved.
 * See COPYING.txt for license details.
 */

namespace Webkul\SalesforceConnector\Controller\Adminhtml\System\Config\Connection;

use Magento\Framework\Controller\Result\JsonFactory;
use Magento\Framework\App\PageCache\Version;
use Magento\Framework\App\Cache\TypeListInterface;
use Magento\Framework\App\Cache\Frontend\Pool;

class InitialChecks extends \Webkul\SalesforceConnector\Controller\Adminhtml\System\Config\Connection
{
    /**
     * @var JsonFactory
     */
    protected $_json;
    protected $writerInterface;
    protected $_curl;
    protected $cacheTypeList;
    protected $cacheFrontendPool;
    /**
     * @param \Magento\Backend\App\Action\Context $context
     * @param \Webkul\Eshopsync\Helper\Connection $connection
     * @param \Webkul\Eshopsync\Helper\Data $helper
     * @param \Magento\Config\Model\ResourceModel\Config $resourceConfig
     * @param \Magento\Framework\View\Result\PageFactory $resultPageFactory
     * @param \Magento\Framework\HTTP\Client\Curl $curl
     */
    public function __construct(
        \Magento\Backend\App\Action\Context $context,
        \Magento\Framework\Json\Helper\Data $jsonHelper,
        \Magento\Framework\App\Config\Storage\WriterInterface $writerInterface,
        TypeListInterface $cacheTypeList,
        Pool $cacheFrontendPool,
        \Magento\Framework\HTTP\Client\Curl $curl
    ) {

        parent::__construct($context);
        $this->writerInterface = $writerInterface;
        $this->_json = $jsonHelper;
        $this->_curl = $curl;
        $this->cacheTypeList = $cacheTypeList;
        $this->cacheFrontendPool = $cacheFrontendPool;
    }

    public function execute()
    {   
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $magentoMetaData = $objectManager->create('\Magento\Framework\App\ProductMetadataInterface');
        $data = $objectManager->create('\Webkul\SalesforceConnector\Helper\Data');
        $appEdition = $data->getConfigValue('general', 'mgedition');
        if (($magentoMetaData->getEdition() == 'Community' && $appEdition == 1) || ($magentoMetaData->getEdition() == 'Enterprise' && $appEdition == 0)) {
            $error = ($appEdition == 0) ? "you seem to be using Community edition of this extension but have Enterprise edition of Magento. Kindly install the correct version of SalesforceConnector" : "you seem to be using Enterprise edition of this extension but have community edition of Magento. Kindly install the correct version of SalesforceConnector";
            $this->getResponse()->setHeader('Content-type', 'application/json');
            $this->getResponse()->setBody($error);
        }
        else{
            $this->getResponse()->setHeader('Content-type', 'application/json');
            $this->getResponse()->setBody(1);
        }
    }

    /*
     * Check permission via ACL resource
     */
}
