<?php
/**
 * Webkul Software.
 *
 * @category  Webkul
 * @package   Webkul_Eshopsync
 * @author    Webkul Software Private Limited
 * @copyright Copyright (c) 2010-2017 Webkul Software Private Limited (https://webkul.com)
 * @license   https://store.webkul.com/license.html
 */

namespace Webkul\SalesforceConnector\Observer;
 
use Magento\Framework\Event\ObserverInterface;
use Magento\Framework\Event\Observer;
use Magento\Framework\App\RequestInterface;

class OnCategorySave implements ObserverInterface
{
 
    /** @var \Magento\Framework\Logger\Monolog */
    protected $_logger;

    /** @var \Webkul\Eshopsync\Helper\Connection */
    protected $_helperConnection;
    protected $_helperData;

    /** @var \Webkul\Eshopsync\Helper\Category */
    protected $_helperCategory;

    /** @var Magento\Framework\App\RequestInterface */
    protected $_request;

    /** @var \Webkul\Eshopsync\Model\CategoryFactory */
    protected $_eshopsyncCategory;

    /** @var \Magento\Catalog\Model\CategoryFactory */
    protected $_catalogCategory;

    /**
     * @param \Psr\Log\LoggerInterface                   $loggerInterface
     * @param \Webkul\Eshopsync\Helper\Connection        $helperConnection
     * @param \Webkul\Eshopsync\Helper\Category          $helperCategory
     * @param RequestInterface                           $requestInterface
     * @param \Webkul\Eshopsync\Model\CategoryFactory    $eshopsyncCategory
     * @param \Magento\Catalog\Model\CategoryFactory     $catalogCategory
     */
    public function __construct(
        \Psr\Log\LoggerInterface $loggerInterface,
        \Webkul\SalesforceConnector\Helper\Connection $helperConnection,
        \Webkul\SalesforceConnector\Helper\Data $helperData,
        \Webkul\SalesforceConnector\Helper\Category $helperCategory,
        RequestInterface $requestInterface,
        \Webkul\SalesforceConnector\Model\CategoryFactory $eshopsyncCategory,
        \Magento\Catalog\Model\CategoryFactory $catalogCategory
    ) {
    
        $this->_logger = $loggerInterface;
        $this->_helperConnection = $helperConnection;
        $this->_helperData = $helperData;
        $this->_helperCategory = $helperCategory;
        $this->_request = $requestInterface;
        $this->_eshopsyncCategory = $eshopsyncCategory;
        $this->_catalogCategory = $catalogCategory;
    }
    /**
     * This is the method that fires when the event runs.
     *
     * @param Observer $observer
     */

    public function execute(Observer $observer)
    {
        $category = $observer->getEvent()->getCategory();
        $controller = $this->_request->getControllerName();
        if ($controller == "category" && $category) {
            // $mappingId = 0;
            $catId = $category->getId();
            if ($catId) {
                // $model = $this->_eshopsyncCategory->create();
                $autoSync = $this->_helperData->getConfigValue('autoSync', 'autoSyncCatSync');
                if ($autoSync) {
                    $this->_helperCategory->exportSpecificCategory($catId);
                    // $data =  $this->_helperData->fetchMappingDetails($this->_eshopsyncCategory, $catId);
                }
                /* $collection = $model->getCollection()
                                    ->addFieldToFilter('magento_id', ['eq'=>$catId]);
                if (count($collection)) {
                    foreach ($collection as $map) {
                        $mappingId = $map->getEntityId();
                    }
                    if (!$autoSync && $mappingId) {
                        $this->_helperCategory->updateMapping($mappingId, 'yes');
                    }
                }
                $client = $this->_helperConnection->getSforceConnection();
                if ($client['client'] && $autoSync) {
                    $categoryModel = $this->_catalogCategory->create()->load($catId);
                    $categoryModel->setName($category->getName());
                    $categoryModel->setMetaTitle($category->getMetaTitle());
                    $categoryModel->setMetaKeywords($category->getMetaKeywords());
                    $categoryModel->setMetaDescription($category->getMetaDescription());
                    $categoryModel->setDescription($category->getDescription());
                    $categoryModel->setParentId($category->getParentId());
                    $categoryModel->save();
                    if ($mappingId) {
                        $this->_helperCategory->updateSpecificCategory($client['client'], $mappingId);
                    } else {
                        $response = $this->_helperCategory->exportSpecificCategory($client['client'], $catId);
                    }
                } */
            }
        }
        return true;
    }
}
